

gokakyuHandler = {
	shellNum = 1,
	shells = {},
	defaultShell = {active = false, strength = 50.5, maxDist = 70000.5, maxMass = 1500000}, --1500 maxmass
}

muzzleflash = LoadSprite("gfx/glare.png")

function init()
	RegisterTool("BBA", "Big Bang Attack", "MOD/vox/gokakyu.vox")
	SetBool("game.tool.BBA.enabled", true)
	SetFloat("game.tool.BBA.ammo", 101)
	
	ballgravity = Vec(0, 0, 0)
	hadoukendamage = 50 --1.5
	velocity = 0.9	--0.2
	swingTimer = 0
	strength = 100
	blasttimer = 0
	ExplFlash = 0
	ToolReady = 0
	ready = 0
	coolDown = 0
    recoil = 0
	recoilTimer = 0
	camTimer = 0
	camTimerr = 0
	kiblast = false
	timedexpl = 0	
	aa = true
	timer = 0
	n2 = 0
	n3 = 0
	n4 = 0
	startCameraMovement = false
	startCameraMovement1 = false
	toolactive = false
	n4state = false
	
	UiScaling = 1
	uirot = 0
	particl = 0
	
	for i=1, 100 do
		gokakyuHandler.shells[i] = deepcopy(gokakyuHandler.defaultShell)
	end
	
	KiTravel = LoadLoop("snd/KiTravel.ogg")
	KiBlastCharge4 = LoadSound("snd/KiBlastCharge4.ogg")
	gokakyusound1 = LoadLoop("snd/KiBlastCharge.ogg")
	gokakyusound2 = LoadSound("snd/KiBlastBigCombined4.ogg")
	gokakyusound3 = LoadSound("snd/KiBlastBig.ogg")
	gokakyusound4 = LoadSound("snd/KiBlastBigExplosion12Efficient.ogg")
	gokakyusound5 = LoadSound("snd/KiBlastBigExplosion2Efficient.ogg")
	KiBlastCharge3 = LoadSound("snd/KiBlastCharge3.ogg")
	

	gokakyuSprite2 = LoadSprite("img/YellowKiBlast.png") --gokakyuball2
	gokakyuSprite3 = LoadSprite("img/Glow.png") --gokakyuball2
end

function canShoot()
	local vehicle = GetPlayerVehicle()
	if vehicle ~= 0 then
		local driverPos = GetVehicleDriverPos(vehicle)
		local t = GetVehicleTransform(vehicle)
		local worldPos = TransformToParentPoint(t, driverPos)
		local cameraPos = GetCameraTransform().pos
		local length = VecLength(VecSub(cameraPos, worldPos))

		if length < 1 then
			return true
		else
			return false
		end
	end
	return true
end

function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else
        copy = orig
    end
    return copy
end

function GetAimPos()
	local ct = GetCameraTransform()
	local forwardPos = TransformToParentPoint(ct, Vec(0, 0, -100))
    local direction = VecSub(forwardPos, ct.pos)
    local distance = VecLength(direction)
	local direction = VecNormalize(direction)
	local hit, hitDistance = QueryRaycast(ct.pos, direction, distance)
	if hit then
		forwardPos = TransformToParentPoint(ct, Vec(0, 0, -hitDistance))
		distance = hitDistance
	end
	return forwardPos, hit, distance
end

function rnd(mi, ma)
	return math.random(0, 1000)/1000*(ma-mi)+mi
end

function rndVec(t)
	return Vec(rnd(-t, t), rnd(-t, t), rnd(-t, t))
end

function Shoot()
	aimpos, hit, distance = GetAimPos()
	local direction = VecSub(aimpos, toolPos)
	startCameraMovement = true
	startCameraMovement1 = true
	toolactive = true
	n2 = 0
	n3 = 0
	n4 = 0
	particl = 0
	camTimerr = 0
	camTimer = 0.25
		if distance > 19 then
		PlaySound(gokakyusound2, toolPos, 5) --DebugPrint("hi5")
		end
		local v = VecAdd(Vec(-6, 6, 0), rndVec(rnd(6*0.5, 6*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		local v1 = VecAdd(Vec(6, 6, 0), rndVec(rnd(6*0.5, 6*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		local v2 = VecAdd(Vec(-4, 4, 0), rndVec(rnd(4*0.5, 4*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		local v3 = VecAdd(Vec(4, 4, 0), rndVec(rnd(4*0.5, 4*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		local v4 = VecAdd(Vec(-2, 2, 0), rndVec(rnd(2*0.5, 2*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		local v5 = VecAdd(Vec(2, 2, 0), rndVec(rnd(2*0.5, 2*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		local life = rnd(0.75, 0.85)
		life = life*life * 0.65
		ParticleReset()
		ParticleStretch(5)
		ParticleAlpha(1, 0)
		ParticleEmissive(math.random(2,5), 1.5, "easeout")
		ParticleGravity(-10)
		ParticleRadius(0.3, 0, "easein")
		ParticleColor(0, 0.4, 1)
		ParticleTile(0)
		for i=1, 5 do
		SpawnParticle(toolPos, v, life)
		SpawnParticle(toolPos, v1, life)
		SpawnParticle(toolPos, v2, life)
		local life = rnd(0.75, 0.85)
		life = life*life * 0.75
		SpawnParticle(toolPos, v3, life)
		SpawnParticle(toolPos, v4, life)
		SpawnParticle(toolPos, v5, life)
		end
		
	gokakyuHandler.shells[gokakyuHandler.shellNum] = deepcopy(gokakyuHandler.defaultShell)
	loadedShell = gokakyuHandler.shells[gokakyuHandler.shellNum] 
	loadedShell.active = true
	loadedShell.pos = toolPos
	loadedShell.counter = 1
	loadedShell.predictedBulletVelocity = VecScale(direction, velocity*(100/distance))
	gokakyuHandler.shellNum = (gokakyuHandler.shellNum%#gokakyuHandler.shells) +1
	recoilTimer = coolDown
	swingTimer = 0.3
end

function rnd1(mi, ma)
	return math.random(0.25, 3)/3*(ma-mi)+mi
end

function update(dt)
end

function RandomVector(magnitude)
    local x = Random()
    local y = Random()
    local z = Random()
    return Vec((x - 0.5) * 2 * magnitude, (y - 0.5) * 2 * magnitude, (z - 0.5) * 2 * magnitude)
end

function Random()
    return math.random(0, 1000) / 1000
end

function gokakyuOperations(projectile)
	projectile.predictedBulletVelocity = VecAdd(projectile.predictedBulletVelocity, (VecScale(ballgravity, GetTimeStep())))
	local point2 = VecAdd(projectile.pos, VecScale(projectile.predictedBulletVelocity, GetTimeStep()))
	local dir = VecNormalize(VecSub(point2, projectile.pos))
	local hit, dist, normal, shape = QueryRaycast(projectile.pos, dir, VecLength(VecSub(point2, projectile.pos)))
	
	if particl > 0 and particl < 0.05 then
		ParticleReset()
		ParticleCollide(0)
		ParticleEmissive(5,3)
		ParticleTile(15)
		ParticleRadius(1, 5)
		ParticleColor(0, math.random(300, 500)/1000, 1)
		for i=1, 3 do
		SpawnParticle(projectile.pos, 0, 0.325)
		end
	end

	if distance>75 and projectile.active == true then
	PlayLoop(KiTravel, projectile.pos, 12)
	end
	
	if hit then
	aa = false
	timedexpl = 0
	--DebugPrint("hit")
		DrawBodyOutline(shape, 0, 1, 0, 1)
		ExplFlash = math.random(80,140)
		hitPos = VecAdd(projectile.pos, VecScale(VecNormalize(VecSub(point2, projectile.pos)), dist))
		hitPos1andahalf = VecAdd(projectile.pos, VecScale(VecNormalize(VecSub(point2, projectile.pos)), dist - 1))
		hitPos2 = VecAdd(projectile.pos, VecScale(VecNormalize(VecSub(point2, projectile.pos)), dist + 4.5))
		hitPos3 = VecAdd(projectile.pos, VecScale(VecNormalize(VecSub(point2, projectile.pos)), dist + 8.5))
		hitPos4 = VecAdd(projectile.pos, VecScale(VecNormalize(VecSub(point2, projectile.pos)), dist + 10.75))
		projectile.active = false --false
		Paint(hitPos2, 4.2, "explosion")
		Paint(hitPos2, 4, "explosion")
		Paint(hitPos3, 3.4, "explosion")
		Paint(hitPos3, 3.2, "explosion")
		Paint(hitPos4, 2.2, "explosion")
		Paint(hitPos4, 2, "explosion")
		
		Paint(hitPos, 8, "explosion")
		Paint(hitPos, 8.5, "explosion")
		for i=1, 1 do
		MakeHole(hitPos, 4.5, 4.25, 4, false)
		MakeHole(hitPos, 2.5, 2.25, 2, "silent")
		end
		
		s = math.random(0.5, 0.8) --0.5, 0.8
		lol = math.random(1, 2)
		lolol = math.random(1, 100)
		lol1 = math.random(1, 2)
		lolol1 = math.random(1, 100)
		if distance<25 then
			if lol==1 then
			ShakeCamera(0.9) 
			PlaySound(gokakyusound4, hitPos, 2) 
			elseif lol==2 then
			ShakeCamera(1) 
			PlaySound(gokakyusound5, hitPos, 2) 
			end

		end						
		if distance>25 then
			if lol1==1 then
			ShakeCamera(1.05) 
			PlaySound(gokakyusound4, hitPos, 7.3) 
			elseif lol1==2 then
			ShakeCamera(1.15) 
			PlaySound(gokakyusound5, hitPos, 7.3) 
		end

		end					
			max = 12
			local objectbodies = QueryAabbBodies( VecAdd(hitPos, Vec(-max, -max, -max)), VecAdd(hitPos, Vec(max, max, max)))
            for i = 1, #objectbodies do
                local objectbodies2 = objectbodies[i]
                if IsBodyDynamic(objectbodies2) then
                  local bb, bbba = GetBodyBounds(objectbodies2)
                  local direction = VecSub(VecLerp(bb, bbba, 0.5), hitPos)
                  local distance = VecLength(direction)
                  direction = VecScale(direction, 1 / distance)
                  if distance < max and IsBodyVisible(objectbodies2, max * 100) and projectile.active == false then --max * 100
                    local distScale = 1 - math.min(distance / max, 0.9)
                    local vel = GetBodyVelocity(objectbodies2)
					local angVel = GetBodyAngularVelocity(objectbodies2)
					local abccc = math.random(10, 20)
                    vel = VecAdd(GetBodyVelocity(objectbodies2), VecScale(direction, abccc * distScale))
					local abcc = math.random(-2, 2)
					angVel = VecAdd(GetBodyAngularVelocity(objectbodies2), VecScale(direction, abcc * distScale)) 
					local hitbody = GetShapeBody(shape)
					local mass = GetBodyMass(hitbody)
					if mass > 100000 then
					end
					if mass < 100000 then
                    SetBodyVelocity(objectbodies2, vel)
					SetBodyAngularVelocity(objectbodies2, angVel)
					end
					end
				  end
			   end	

			local t = GetPlayerCameraTransform()
			local dir = TransformToParentVec(t, Vec(0, 0.15, -1))
			local hitbody = GetShapeBody(shape)
			local mass = GetBodyMass(hitbody)
			--DebugPrint(mass)
			if mass > 100000 then
			end
			if mass < 100000 then
			ApplyBodyImpulse(hitbody,hitPos,VecScale(dir,mass*55))
			end
	
	--hitpos energy
		for i=1, 50 do
			local v = VecAdd(Vec(0, 2.3, 0 ), rndVec(rnd(-2.5*0.5, 2.9*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
			local life = rnd(0, 1)
			life = life*life * 1.4
			ParticleReset()
			ParticleStretch(2)
			ParticleAlpha(1,0)
			ParticleEmissive(5, 1, "easeout")
			ParticleGravity(math.random(-10, 1))
			ParticleRadius(0, 1.5, "easein")
			ParticleColor(0, math.random(35, 75)/100, 1)
			ParticleTile(5)
			SpawnParticle(hitPos, v, life)
		end
		--debris
	for i=1, 100 do
		local v = VecAdd(Vec(0, 14, 0 ), rndVec(rnd(18*0.5, 22*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		local life = rnd(0, 1.0)
		life = life*life * 3
		ParticleReset()
		ParticleEmissive(0, 0, "easeout")
		ParticleGravity(-25)
		ParticleRadius(0.15, 0.0, "easein")
		ParticleColor(0.3, 0.3, 0.3)
		ParticleTile(6)
		SpawnParticle(hitPos, v, life)
	end
		local e = Transform(Vec(), QuatAxisAngle(Vec(1, 0, 0), math.sin(3.0) * 3.0))
		SetPlayerCameraOffsetTransform(e)
--blueshockwave
	for i=1, 5 do
		ParticleReset()
		local v = VecAdd(Vec(0, 9, 0 ), rndVec(rnd(14*0.5, -19*1.5)))
		ParticleAlpha(0.65, 0)
		ParticleRadius(0, 5)
		ParticleEmissive(4, 2)
		ParticleColor(0, 0.45, 1)
		ParticleTile(0)
		SpawnParticle(hitPos, v, 0.5)
	end
	for i=1, 5 do
		ParticleReset()
		local v = VecAdd(Vec(0, 14, 0 ), rndVec(rnd(19*0.5, -24*1.5)))
		ParticleAlpha(0.65, 0)
		ParticleRadius(0, 5)
		ParticleEmissive(3, 2)
		ParticleColor(0, 0.45, 1)
		ParticleTile(0)
		SpawnParticle(hitPos, v, 0.5)
	end
	
	--dark smoke
	for i=1, 12 do
		ParticleReset()
		local v = VecAdd(Vec(0, 9, 0 ), rndVec(rnd(14*0.5, 19*1.5)))
		ParticleRadius(0, 5)
		ParticleEmissive(0, 0)
		ParticleColor(0.01, 0.01, 0.01)
		ParticleTile(0)
		SpawnParticle(hitPos, v, 0.85)
	end
	--dark smoke
	for i=1, 12 do
		ParticleReset()
		local v = VecAdd(Vec(0, 9, 0 ), rndVec(rnd(14*0.5, 19*1.5)))
		ParticleRadius(0, 5)
		ParticleEmissive(0, 0)
		ParticleColor(0.01, 0.01, 0.01)
		ParticleTile(0)
		SpawnParticle(hitPos, v, 0.75)
	end

	for i=1, 250 do
	--sparks
		local v = VecAdd(Vec(0, 7, 0 ), rndVec(rnd(11*0.5, 15*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		local life = rnd(0, 1.1)
		life = life*life * 5
		ParticleReset()
		ParticleEmissive(5, 1, "easeout")
		ParticleGravity(-20)
		ParticleRadius(0.045, 0.0, "easein")
		ParticleColor(1, 0.4, 0.3)
		ParticleTile(4)
		SpawnParticle(hitPos, v, life)
	end
	--blue energy scatter
	for i=1, 50 do
		local v = VecAdd(Vec(0, 15, 0 ), rndVec(rnd(17*0.5, 21*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		local life = rnd(0, 0.75)
		life = life*life * 1.5
		ParticleReset()
		ParticleStretch(5)
		ParticleAlpha(1,0)
		ParticleEmissive(5, 1, "easeout")
		ParticleGravity(-25)
		ParticleRadius(0, 1, "easein")
		ParticleColor(0, 0.25, 1)
		ParticleTile(4)
		SpawnParticle(hitPos, v, life)
	end
	--blue energy scatter
	for i=1, 50 do
		local v = VecAdd(Vec(0, 15, 0 ), rndVec(rnd(17*0.5, 21*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		local life = rnd(0, 0.7)
		life = life*life * 1.5
		ParticleReset()
		ParticleStretch(5)
		ParticleAlpha(1,0)
		ParticleEmissive(5, 1, "easeout")
		ParticleGravity(-25)
		ParticleRadius(0, 0.75, "easein")
		ParticleColor(0, 0.25, 1) --weird one
		ParticleTile(4)
		SpawnParticle(hitPos, v, life)
	end
		--sitting still at hitpos
		for i=1, 10 do
		local v = VecAdd(Vec(0, 2, 0 ), rndVec(rnd(4*0.5, 6*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
		local life = rnd(0, 1)
		life = life*life * 0.5
		ParticleReset()
		ParticleEmissive(5, 1, "easeout")
		ParticleGravity(-10)
		ParticleRadius(0, 4, "easein")
		ParticleColor(0, 0.5, 1)
		ParticleTile(4)
		SpawnParticle(hitPos, v, life)
	end
	--blue energy scatter
		for i=1, 50 do
			local v = VecAdd(Vec(0, 9, 0 ), rndVec(rnd(16*0.5, 20*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
			local life = rnd(0, 0.75)
			life = life*life * 1.5
			ParticleReset()
			ParticleStretch(5)
			ParticleEmissive(5, 5, "easeout")
			ParticleGravity(-10)
			ParticleRadius(0, 0.75)
			ParticleColor(0, 0.25, 1)
			ParticleTile(4)
			SpawnParticle(hitPos, v, life)
		end
		
	end

	local rot = QuatLookAt(projectile.pos, GetCameraTransform().pos)
	local transform = Transform(projectile.pos, rot)
	ee = math.random(1,1.1)
	eee = math.random(2,math.random(2*2,2*3))
	eeee = math.random(1,math.random(1*1.5,1*2))
	DrawSprite(gokakyuSprite3, transform, eee, eee, 0, 0.65, 1, 0.75, true, false)
	DrawSprite(gokakyuSprite3, transform, eeee, eeee, 1, 1, 1, 0.75, true, false)	--2,2,1,1,1,0.75

	projectile.counter = projectile.counter + 1
    projectile.pos = point2
	ee = math.random(1,1.1)
	eee = math.random(15,math.random(45*2.5,45*5))
	PointLight(projectile.pos, 0, 0.4, ee, eee) --0.5, 0.5

	local t = GetPlayerCameraTransform()
	local dir = TransformToParentVec(t, Vec(0, 0, -1))
	local hitbody = GetShapeBody(shape)
	local mass = GetBodyMass(hitbody)
	if mass > 100000 then
	end
	if mass < 100000 then
	ApplyBodyImpulse(hitbody,hitPos,VecScale(dir,mass*-30))
	end
end

function rndVec(length)
	local v = VecNormalize(Vec(math.random(-100,100), math.random(-100,100), math.random(-100,100)))
	return VecScale(v, length)	
end

function NumberLerp(a,b,f)
    return a*(1-f)+b*f
end

function draw()
if startCameraMovement == true then
	UiBlur(0.55)
end
end

function tick(dt)

	if GetString("game.player.tool") == "BBA" and GetPlayerVehicle() == 0 then
		SetBool("game.input.locktool", flycamenabled)
		firing = InputDown("usetool")
		if ToolReady < 1 then
		
		end
		
		if ExplFlash > 0 then
			local aa = TransformToParentVec(hitPos, Vec(0, 1, 0))
		    local a = VecAdd (hitPos1andahalf, Vec(0, 0.1, 0))
			local b = math.random(180, 280)
			local d = math.random(4, 12.5)
			local d1 = math.random(1.5, 2.25)
			PointLight(a, 0, 0.6, 1, ExplFlash*d)
			if ExplFlash > 0.1 then
			PointLight(a, 1, 1, 1, ExplFlash*d1)
			end
			ExplFlash = ExplFlash - dt*b
		end
		
	if aa == false then
	if timedexpl > 0.15 then
		for i=1, 50 do
			local v = VecAdd(Vec(0, 2.7, 0 ), rndVec(rnd(-2.9*0.5, 3.3*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
			local life = rnd(0, 0.9)
			life = life*life * 1.5
			ParticleReset()
			ParticleStretch(2)
			ParticleAlpha(1,0)
			ParticleEmissive(5, 1, "easeout")
			ParticleGravity(math.random(-10, 1))
			ParticleRadius(0, 1.5, "easein")
			ParticleColor(0, math.random(35, 75)/100, 1)
			ParticleTile(5)
			SpawnParticle(hitPos2, v, life)
		end
		MakeHole(hitPos2, 3.5,3.25,3, "silent")
		MakeHole(hitPos2, 2.5,2.25,2, "silent")
		end
		if timedexpl > 0.245 then
		for i=1, 50 do
			local v = VecAdd(Vec(0, 2.7, 0 ), rndVec(rnd(-2.9*0.5, 3.3*1.5))) --VecAdd(Vec(0, 15, 0 ), rndVec(rnd(15*0.5, 15*1.5)))
			local life = rnd(0, 0.9)
			life = life*life * 1.5
			ParticleReset()
			ParticleStretch(2)
			ParticleAlpha(1,0)
			ParticleEmissive(5, 1, "easeout")
			ParticleGravity(math.random(-10, 1))
			ParticleRadius(0, 1.5, "easein")
			ParticleColor(0, math.random(35, 75)/100, 1)
			ParticleTile(5)
			SpawnParticle(hitPos3, v, life)
		end
		MakeHole(hitPos3, 3.25,3,2.75, "silent")
		MakeHole(hitPos4, 1.5,1.25,1, "silent")
		end
		if timedexpl > 0.248 then
		max = 16
			local objectbodies = QueryAabbBodies( VecAdd(hitPos, Vec(-max, -max, -max)), VecAdd(hitPos, Vec(max, max, max)))
            for i = 1, #objectbodies do
                local objectbodies2 = objectbodies[i]
                if IsBodyDynamic(objectbodies2) then
                  local bb, bbba = GetBodyBounds(objectbodies2)
                  local direction = VecSub(VecLerp(bb, bbba, 0.5), hitPos)
                  local distance = VecLength(direction)
                  direction = VecScale(direction, 1 / distance)
                  if distance < max and IsBodyVisible(objectbodies2, max * 100) and timedexpl > 0.245 then --max * 100
                    local distScale = 1 - math.min(distance / max, 0.9)
                    local vel = GetBodyVelocity(objectbodies2)
					local angVel = GetBodyAngularVelocity(objectbodies2)
					local abccc = math.random(10, 20)
                    vel = VecAdd(GetBodyVelocity(objectbodies2), VecScale(direction, abccc * distScale))
					local abcc = math.random(-2, 2)
					angVel = VecAdd(GetBodyAngularVelocity(objectbodies2), VecScale(direction, abcc * distScale)) 
					SetBodyVelocity(objectbodies2, vel)
					SetBodyAngularVelocity(objectbodies2, angVel)
					end
				  end
			   end	
		end
		if timedexpl > 0.250 then
		aa = true
		end
		end
	end
	
	if GetString("game.player.tool") == "BBA" and canShoot() then
	
			local b = GetToolBody()
			if b ~= 0 then
			local offset = Transform(Vec(0.4, -0.5, -0.48))-- 0.4, -0.5, -0.28 0.8, -1, -0.56
			SetToolTransform(offset)
			toolTrans = GetBodyTransform(b)
			toolPos = TransformToParentPoint(toolTrans, Vec(0.12, 0.2, -0.8)) -- 0.3, -0.45, -2.4 0.6, -0.9, -4.8
			local body = GetPlayerGrabBody()
            local shape = GetPlayerGrabShape()
					
				if InputPressed("lmb") and shape == 0 and body == 0 then
				if camTimerr < 1.5 then
				rndsound = math.random(1, 2)
				if rndsound == 1 then
				PlaySound(KiBlastCharge3, toolPos, 0.35)
				elseif rndsound == 2 then
				PlaySound(KiBlastCharge4, toolPos, 0.75)
				end
				end
				end
				
				if InputDown("lmb") and shape == 0 and body == 0 then
				kiblast = true
				if kiblast == true then
				
				camTimerr = camTimerr + dt
				local rot = QuatLookAt(toolPos, GetCameraTransform().pos)
				local transform = Transform(toolPos, rot)
				maxsize = 1
				maxsize1 = camTimerr + maxsize
					if maxsize1 < 2 then
					if camTimerr < 1 then
					end
					PointLight(toolPos, 0, 0.4, 1, camTimerr * 10)
					eeee = camTimerr + 100/1000
					eeee1 = math.random(eeee*0.01, eeee/0.5)
					eee = eeee*1.75
					DrawSprite(gokakyuSprite3, transform, eee, eee, 0, 0.65, 1, 0.75, true, false)
					DrawSprite(gokakyuSprite3, transform, eeee1, eeee1, 1, 1, 1, 0.75, true, false)
					elseif maxsize1 > 2 then
					PlayLoop(gokakyusound1, toolPos, 1.75)
					ee1 = math.random(5,math.random(5*1,5*3))
					eee1 = math.random(125, 175)/100
					eee11 = math.random(30, 40)/100
					eeee12 = math.random(50, 100)/100
							-- = math.random(0.75, 1.5)
					PointLight(toolPos, 0, 0.4, 1, ee1)
					DrawSprite(gokakyuSprite3, transform, eee1, eee1, 0, 0.65, 1, eee11, true, false)
					DrawSprite(gokakyuSprite3, transform, eeee12, eeee12, 1, 1, 1, 0.65, true, false)
					end
				end
				end
				local fov = GetInt("options.gfx.fov")
				local cfov = fov*1.35
				local vel = GetPlayerVelocity()
				local t = GetCameraTransform()
				local localBack = Vec(0, 0, 1.6)
				local back = TransformToParentVec(t, localBack)
				local back1 = VecAdd(vel, back)
				
				if 	toolactive == true then
				if n3 < 0.2 then
				SetPlayerVelocity(back1)
				if n2 < 1 and startCameraMovement == true then
				SetValue("UiScaling", 2.5, "linear", 0.2)
				uirot = math.random(100, 400)/1000
				ff1 = NumberLerp(fov,cfov,n2)
				SetCameraFov(ff1)
				elseif n2 > 1 then
				SetValue("UiScaling", 1, "linear", 0.2)
				SetCameraFov(cfov)
				startCameraMovement = false
				end
				end
				
				if n3 > 0.2 then
				n4state = true
				if n4 < 1 and startCameraMovement1 == true then
				ff1 = NumberLerp(cfov,fov,n4)
				SetCameraFov(ff1)
				elseif n4 > 1 then
				n4state = false
				startCameraMovement1 = false
				toolactive = false
				end
				end
				end
				
				if InputReleased("lmb") and shape == 0 and body == 0  then 
				
                end
			
				if InputReleased("lmb") and shape == 0 and body == 0  then 
				if GetString("game.player.tool") == "BBA" and GetPlayerVehicle() == 0 then
				
			end
			if coolDown < 0 and camTimerr > 0.5 then
			kiblast = false
			PointLight(toolPos, 1, 1, 0.2, 4)
			Shoot()
			timer = 0
			coolDown = 0.1
			elseif camTimerr < 0.5 then
			camTimerr = 0

		end
	end
	coolDown = coolDown - dt
	camTimer = camTimer - dt
	timedexpl = timedexpl + dt
	n2 = n2 + dt*7
	n3 = n3 + dt
	if n4state == true then
	n4 = n4 + dt*3
	end
	particl = particl + dt

end
	
	for key, shell in ipairs(gokakyuHandler.shells) do
		if shell.active then
			gokakyuOperations(shell)
		end
	end
	end
	end